#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>

#include "../IDL/shop.h"

	//Library entry
	struct Book bookEntry;
	int bookPrice = 100;

	//Customer information
	unsigned char* customerBankName = (unsigned char*)"Banca Popolare di Lodi";
	long customerAccountNumber = 987654;

	struct Receipt receipt;

void main()
{
    //Connection status
	RPC_STATUS status;

	//underlying network transport protocol
    unsigned char * pszProtocolSequence = (unsigned char*)"ncacn_np";

	//optional parameter provided for the security subsystem (alwais NULL)
    unsigned char * pszSecurity     = NULL; 
    
	//endpoint-address information
	unsigned char * pszEndpoint    = (unsigned char*)"\\pipe\\bookshop";
	
	//minimun number of calls threads
    unsigned int    cMinCalls      = 1;
    
	//maximun queue length
	unsigned int    cMaxCalls      = 20;

	//define RpcServerListen behaviour
    unsigned int    fDontWait      = FALSE;

	//Library entry
	bookEntry.isbn = 123456;
	bookEntry.name = (unsigned char*)"Divina Commedia";
	
	//use the specified protocol sequence combined with the specified 
	//endpoint for receiving remote procedure calls
	status = RpcServerUseProtseqEp(pszProtocolSequence,cMaxCalls,
                                   pszEndpoint,pszSecurity);
	if (status){
        exit(status);
    }
 
	//registers the interface with the RPC run-time library
    status = RpcServerRegisterIf(bookshop_v1_0_s_ifspec, //interface to register 
                                 NULL,   
                                 NULL); 
	if (status)
	{
        exit(status);
    }
 
	//listen for remote procedure calls
    status = RpcServerListen(cMinCalls,  //minimum number of call threads 
							 cMaxCalls,  //maximum number of concurrent remote procedure calls
                             fDontWait); //define RpcServerListen behaviour

	if (status) 
    {
        exit(status);
    }
}

//Allocate memory before procedure calls
void __RPC_FAR * __RPC_USER MIDL_user_allocate(size_t len)
{
    return(malloc(len));
}
 
//free memory after procedure calls
void __RPC_USER MIDL_user_free(void __RPC_FAR * ptr)
{
    free(ptr);
}

//search a book in the library
struct Book search(unsigned char* keyword){
	printf("Search received for keyword: %s \n",keyword);
	if (strcmp((const char*)keyword,(const char*)bookEntry.name) == 0){
		printf("Book found\n\n\n");
		return bookEntry;
	}
}

//order a book to the library
struct Receipt order(struct Book book){
	printf("Order received for Book : %s \n",book.name);
	if (book.isbn == bookEntry.isbn){
		receipt.bank = customerBankName;
		receipt.accountnumber = customerAccountNumber;
		receipt.amount = bookPrice;
		
		printf("Order sent\n\n\n");
		return receipt;
	}
}

